package fi.jyu.mit.graphics;

/**
 * Luokka jolla voi pyorittaa kuvia
 * @author Vesa Lappalainen
 * @author Markus Kivioja
 */
public class Rotator extends BasicTransformer {

    /**
     * Luo uuden pyrittjn
     * @param object olio jota pyritetn
     * @param axis akseli jonka suhteen pyritetn (Axis.X/Axis.Y/Axis.Z)
     * @param deg yhden pyrhdysaskeleen suuruus asteina
     * @param dt pyrhdysaskeleiden vlinen aika millisekunteina
     */
    public Rotator(Transformable object, int axis, double deg, long dt) {
        this(object, new RotMatrix(axis, deg), dt);
    }


    /**
     * Luo uuden pyrittjn
     * @param object olio jota pyritetn
     * @param rotM kiertomatriisi jolla pyritetn
     * @param dt pyrhdysaskeleiden vlinen aika millisekunteina
     */
    public Rotator(Transformable object, Matrix rotM, long dt) {
        super(object, rotM, dt);
    }


    /**
     * Ajaa yhden pyritysaskeleen
     */
    @Override
    public void run() {
        Matrix rot2 = getObject().getRotator();
        if (rot2 == null)
            rot2 = getTransform();
        else
            rot2 = rot2.multiply(getTransform());
        getObject().setRotator(rot2);
    }

}
