package fi.jyu.mit.graphics;

/**
 * Rajapinta olioille joita voidaan muuntaa matriisilla
 * @author Vesa Lappalainen
 * @author Markus Kivioja
 */
public interface Transformable {

    /**
     * Muuntaa oliota muunosmatriisilla m
     * @param m matriisi jolla olion nykyinen muunnosmatrisi kerrotaan
     * @return muutettu matriisi
     */
    Transformable transform(Matrix m);


    /**
     * Vaihtaa olion muunnosmatriisiksi m:n
     * @param m matriisi joka asetetaan olion muunnomatriisiksi
     */
    void changeTransform(Matrix m);


    /**
     * Asettaa oliolle kiertomatriisin
     * @param m matriisi joka asetetaan olion kiertomatriisiksi
     */
    void setRotator(Matrix m);


    /**
     * Antaa olion muunnosmatriisin
     * @return olion muunnomatriisi
     */
    Matrix getTransform();


    /**
     * Antaa olion kiertomatriisin
     * @return olion kiertomatriisi
     */
    Matrix getRotator();
}
