package sample;

import java.awt.Color;

import fi.jyu.mit.graphics.Circle;
import fi.jyu.mit.graphics.ControlButtons;
import fi.jyu.mit.graphics.ControllerFrame;
import fi.jyu.mit.graphics.DrawableCollection;
import fi.jyu.mit.graphics.Line;
import fi.jyu.mit.graphics.Polygon;
import fi.jyu.mit.graphics.TouchPad;
import fi.jyu.mit.graphics.Window;
import sample.UkkoSample.Ukko;

/**
 * 
 * @author Markus Kivioja
 *
 */
public class CarSample {

    /**
     * Luokka yhdelle autolle.
     * @author Markus
     */
    public static class Car extends DrawableCollection {

        /**
         * Alustetaan uusi auto
         * @param x auton paikka
         * @param y auton paikka
         * @param z auton paikka
         */
        public Car(double x, double y, double z) {
            super();
            move(x, y, z);
            add(new Circle(-2, 0, 1, 0.5));
            add(new Circle(-2, 0, -1, 0.5));
            add(new Circle(2, 0, 1, 0.5));
            add(new Circle(2, 0, -1, 0.5));
            add(new Line(-2, 0, -1, -2, 0, 1));
            add(new Line(2, 0, -1, 2, 0, 1));
            add(new Line(-2, 1, 1, -2, 1, -1)).setColor(0, 0, 255);
            add(new Line(-0.5, 1, 1, -0.5, 1, -1)).setColor(0, 0, 255);
            add(new Line(0.5, 2, 1, 0.5, 2, -1)).setColor(0, 0, 255);
            add(new Line(2, 2, 1, 2, 2, -1)).setColor(0, 0, 255);
            add(new Line(3, 1, 1, 3, 1, -1)).setColor(0, 0, 255);
            add(new Line(-0.5, 1, 1, 3, 1, 1)).setColor(0, 0, 255);
            add(new Line(-0.5, 1, -1, 3, 1, -1)).setColor(0, 0, 255);
            add(new Line(-0.25, 0.2, 1, 0.25, 0.7, 1)).setColor(255, 0, 0);
            add(new Line(-0.25, 0.7, 1, 0.25, 0.2, 1)).setColor(255, 0, 0);
            double[][] points1 = { { -3, 0, 1 }, { -3, 0, -1 }, { -2, 1, -1 },
                    { -0.5, 1, -1 }, { 0.5, 2, -1 }, { 2, 2, -1 }, { 3, 1, -1 },
                    { 3, 0, -1 }, { 3, 0, 1 }, { 3, 1, 1 }, { 2, 2, 1 },
                    { 0.5, 2, 1 }, { -0.5, 1, 1 }, { -2, 1, 1 }, { -3, 0, 1 } };
            add(new Polygon(points1)).setColor(0, 0, 255);
            double[][] points2 = { { -3, 0, 1 }, { -3, 0, -1 }, { 3, 0, -1 },
                    { 3, 0, 1 }, };
            add(new Polygon(points2)).setColor(0, 0, 255);
        }
    }


    /**
     * Piirretn auto ja ukko ja niille ohjaimet
     * @param args ei kytss
     */
    @SuppressWarnings("unused")
    public static void main(String[] args) {
        Window window = new Window();
        Car car = new Car(0, 0, 0);

        window.add(car);
        window.scale(-4, -4, 4, 4);
        window.showWindow();

        window.setTouchPad(true, true);
        window.setControlButtons(true);

        Ukko ukko = new Ukko(-3, 3, 0.01, 180, Color.RED);
        window.add(ukko);
        new ControllerFrame(new TouchPad(ukko), 300, 350, 150, 150);
        new ControllerFrame(new ControlButtons(ukko), 450, 350, 150, 150);
    }
}
