package sample;

import java.util.Timer;
import java.util.TimerTask;
import java.util.Random;

import fi.jyu.mit.graphics.*;

/**
 * Demonstoirdaan kuinka vri voidaan vaihtaa
 * @author vesal
 */
public class ColorChangeSample {
    /**
     * Luokka aiheuttamaan "tapahtumia".
     * @author vesal
     *
     */
    public static class ColorChanger extends TimerTask {
        private final Drawable shape;
        private int r = 0;
        private final Random rand = new Random();


        /**
         * Alustetaan uusi vrinvaihta-olio
         * @param shape kuvion, jonka vri vaihdetaan
         * @param dt aikavli jolloin vaihtamsita tehdn
         */
        public ColorChanger(Drawable shape, long dt) {
            super();
            this.shape = shape;
            new Timer().schedule(this, dt, dt);
        }


        /**
         * Kun vaihtaja lhtee kyntiin, ajetaan tt metodia
         * valitun aikavlin tahtiin.  Arvotaan kohdeoliolle uusi vri.
         */
        @Override
        public void run() {
            r = (r + 10) % 256;
            shape.setColor(rand.nextInt(256), rand.nextInt(256),
                    rand.nextInt(256));
        }
    }


    /**
     * Piirretn viiva joka vaihtaa vri ja toinen joka pyrii.
     * @param args
     */
    @SuppressWarnings("unused")
    public static void main(String[] args) {
        EasyWindow window = new EasyWindow();
        Line line = window.addLine(0, 0, 100, 100);
        window.showWindow();
        new ColorChanger(line, 120);

        Line line2 = window.addLine(0, 0, 150, 0);
        line2.setTransform(new TranslateMatrix(100, 100, 0));
        new Rotator(line2, Axis.Z, 1, 50);
    }

}
