package sample2;

import fi.jyu.mit.graphics.EasyWindow;
import fi.jyu.mit.graphics.Bitmap;
import static fi.jyu.mit.graphics.Bitmap.*;

/**
 * Esimerkki bitmapin piirtmisest
 * @author vesal
 *
 */
public class BitmapSample {

    /**
     * Malli siit miten koko bitmap kydn lpi ja tehdn jotakin pisteille.
     * @param bm muutettava bitmap
     */
    public static void convertGrayScale(Bitmap bm) {
        for (int y = 0; y < bm.getHeight(); y++) {
            for (int x = 0; x < bm.getWidth(); x++) {
                int c = bm.getRGB(x, y);
                int b = brightness(c);
                int c2 = packRGB(b, b, b);
                bm.setRGB(x, y, c2);
            }
        }
    }


    /**
     * Luetaan tiedostosta yksi kuva joka piirretn sellaisenaan.
     * Tmn rinnalle piirretn toinen kuva mustavalkoisena.
     * Kuvien alle piirretn saman kuva niin ett vain punaista vri on kytss 
     * (and = poistaa ne kohdat joissa on 0)
     * ja toinen jossa jokaiseen vriin listn maksimimr punaista 
     * (or = laittaa plle ne kohdat joissa on 1)
     * @param args ei kytss
     */
    public static void main(String[] args) {
        Bitmap bm1 = new Bitmap(0, 0, "sample/CarSample.png");
        Bitmap bm2 = new Bitmap(bm1.getWidth(), 0, bm1);
        Bitmap bm3 = new Bitmap(0, bm1.getHeight(), bm1);
        Bitmap bm4 = new Bitmap(bm1.getWidth(), bm1.getHeight(), bm1);
        EasyWindow window = new EasyWindow(bm1.getWidth() * 2,
                bm1.getHeight() * 2);
        window.add(bm1);
        window.add(bm2);
        window.add(bm3);
        window.add(bm4);

        convertGrayScale(bm2);
        bm3.andPixels(packRGB(255, 0, 0));
        bm4.orPixels(packRGB(255, 0, 0));

        window.redraw();
    }

}
