package fi.jyu.mit.barChart;

import java.awt.AWTEvent;

/**
 * Luokka BarEvent-tapahtumille
 * @author Markus Kivioja
 * @version 25.05.09
 */
public class BarEvent extends AWTEvent {

    private static final long serialVersionUID = 1L;
    /** pylvt ensin */
    public static final int BAR_FIRST = AWTEvent.RESERVED_ID_MAX + 1;
    /** pylvst klikattu */
    public static final int BAR_CLICKED = BAR_FIRST;
    /** pylvt lopuksi */
    public static final int BAR_LAST = BAR_FIRST;
    private double value;


    /**
     * Luo uuden tapahtuman
     * @param source tapahtuman aiheuttanut pylvs
     * @param id tapahtuman tyyppi
     * @param value pylvn korkeus
     */
    public BarEvent(Bar source, int id, double value) {
        super(source, id);
        this.value = value;
    }


    /**
     * Antaa tapahtuman aiheuttaneen pylvn
     * @return tapahtuman aiheuttanut pylvs
     */
    public Bar getBar() {
        return (Bar) super.getSource();
    }


    /**
     * Antaa pylvn korkeuden
     * @return pylvn korkeus
     */
    public double getValue() {
        return this.value;
    }
}
