package fi.jyu.mit.graphics;

import java.awt.*;

/**
 * Luokka viivoille
 * @author Markus Kivioja
 *
 */
public class Line extends BasicShape {

    private RPoint p1, p2;


    /**
     * Alustetaan viiva
     */
    public Line() {
        super();
        this.p1 = new RPoint();
        this.p2 = new RPoint();
    }


    /**
     * Luo uuden viivan
     * @param x1 alkupisteen x-koordinaatti
     * @param y1 alkupisteen y-koordinaatti
     * @param x2 loppupisteen x-koordinaatti
     * @param y2 loppupisteen y-koordinaatti
     */
    public Line(double x1, double y1, double x2, double y2) {
        super();
        this.p1 = new RPoint(x1, y1);
        this.p2 = new RPoint(x2, y2);
    }


    /**
     * Luo uuden viivan
     * @param x1 alkupisteen x-koordinaatti
     * @param y1 alkupisteen y-koordinaatti
     * @param z1 alkupisteen z-koordinaatti
     * @param x2 loppupisteen x-koordinaatti
     * @param y2 loppupisteen y-koordinaatti
     * @param z2 loppupisteen z-koordinaatti
     */
    public Line(double x1, double y1, double z1, double x2, double y2,
            double z2) {
        super();
        this.p1 = new RPoint(x1, y1, z1);
        this.p2 = new RPoint(x2, y2, z2);
    }


    /**
     * Luo uuden viivan
     * @param p1 alkupiste RPoint-oliona
     * @param p2 loppupiste RPoint-oliona
     */
    public Line(RPoint p1, RPoint p2) {
        super();
        this.p1 = p1;
        this.p2 = p2;
    }


    /**
     * Asetetaan viivan pisteet
     * @param x1 alku x
     * @param y1 alku y
     * @param z1 alku z
     * @param x2 loppu x
     * @param y2 loppu y
     * @param z2 loppu z
     */
    public void setPoints(double x1, double y1, double z1, double x2, double y2,
            double z2) {
        this.p1.set(x1, y1, z1);
        this.p2.set(x2, y2, z2);
        this.redraw();
    }


    @Override
    protected void drawShape(Graphics g, Matrix a) {
        SPoint point1 = a.transform(p1);
        SPoint point2 = a.transform(p2);
        g.drawLine(point1.getX(), point1.getY(), point2.getX(), point2.getY());
    }
}
